// ---------------------------------------------------------------------------
//	M88 - PC-88 Emulator
//	Copyright (C) cisc 1999.
// ---------------------------------------------------------------------------
//	Sound Implemention for Win32
// ---------------------------------------------------------------------------
//	$Id: sounddrv.h,v 1.2 2000/09/08 15:05:22 cisc Exp $

#if !defined(win32_sounddrv_h)
#define win32_sounddrv_h

#include "types.h"
#include "common/soundbuf.h"

// ---------------------------------------------------------------------------

namespace WinSoundDriver
{

class Driver
{
public:
	typedef SoundBuffer::Sample Sample;
	
	Driver() {}
	virtual ~Driver() {}

	virtual bool Init(SoundBuffer* sb, HWND hwnd, uint rate, uint ch, uint buflen) = 0;
	virtual bool Cleanup() = 0;
	void MixAlways(bool yes) { mixalways = yes; }

protected:
	SoundBuffer* src;
	uint buffersize;
	uint sampleshift;
	volatile bool playing;
	bool mixalways;
};

}

#endif // !defined(win32_sounddrv_h)
