// ---------------------------------------------------------------------------
//  M88 - PC-8801 emulator
//	Copyright (C) cisc 1998, 2000.
// ---------------------------------------------------------------------------
//	$Id: winmon.h,v 1.2 2000/08/06 09:59:20 cisc Exp $

#if !defined(win32_winmon_h)
#define win32_winmon_h

//	TvF
//	fobO\̂߂ɎgpeLXgEBhE̊Ǘp{NX
//	@\F
//	eLXgobt@CXVCXN[o[T|[g

#include "instthnk.h"
#include "types.h"

// ---------------------------------------------------------------------------

class WinMonitor
{
public:
	WinMonitor();
	~WinMonitor();

	bool Init(LPCTSTR tmpl);
	void Show(HINSTANCE, HWND, bool show);
	
	bool IsOpen() { return !!hwnd; }
	
	void Update();

protected:
	void Locate(int x, int y);
	void Puts(const char*);
	void Putf(const char*, ...);
	int  GetWidth() { return width; }
	int  GetHeight() { return height; }
	int  GetLine() { return line; }
	void SetLines(int nlines);
	bool SetFont(HWND hwnd, int fh);
	void ClearText();
	int  GetScrPos(bool tracking);
	void SetUpdateTimer(int t);
	bool GetTextPos(POINT*);
	virtual BOOL DlgProc(HWND, UINT, WPARAM, LPARAM);
	void ScrollUp();
	void ScrollDown();
	HWND GetHWnd() { return hwnd; }
	virtual void DrawMain(HDC, bool = false);

	HINSTANCE GetHInst() { return hinst; }

private:
	enum
	{
		bkcol = 0x400000,
	};

	virtual void UpdateText();
	virtual int VerticalScroll(int msg);

	static BOOL CALLBACK DlgProcGate(WinMonitor*, HWND, UINT, WPARAM, LPARAM);
	
	void Draw(HWND, HDC);
	void ResizeWindow(HWND);
	
	InstanceThunk dlgproc;
	InstanceThunk edlgproc;
	HWND hwnd;
	HINSTANCE hinst;
	LPCTSTR lptemplate;
	
	HDC hdc;
	HFONT hfont;
	int fontwidth;
	int fontheight;

	HBITMAP hbitmap;
	
	char* txtbuf;
	char* txpbuf;
	char* txtbufptr;
	POINT txp;
	int width;
	int height;

	RECT wndrect;

	int line;
	int nlines;

	int timer;
	int timerinterval;

};


#endif // !defined(win32_winmon_h)
